import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { DeleteAlarmsInput } from "../models/models_0";
import { deserializeAws_queryDeleteAlarmsCommand, serializeAws_queryDeleteAlarmsCommand } from "../protocols/Aws_query";
var DeleteAlarmsCommand = (function (_super) {
    __extends(DeleteAlarmsCommand, _super);
    function DeleteAlarmsCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    DeleteAlarmsCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "CloudWatchClient";
        var commandName = "DeleteAlarmsCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: DeleteAlarmsInput.filterSensitiveLog,
            outputFilterSensitiveLog: function (output) { return output; },
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    DeleteAlarmsCommand.prototype.serialize = function (input, context) {
        return serializeAws_queryDeleteAlarmsCommand(input, context);
    };
    DeleteAlarmsCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_queryDeleteAlarmsCommand(output, context);
    };
    return DeleteAlarmsCommand;
}($Command));
export { DeleteAlarmsCommand };
