import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { DeleteAnomalyDetectorInput, DeleteAnomalyDetectorOutput } from "../models/models_0";
import { deserializeAws_queryDeleteAnomalyDetectorCommand, serializeAws_queryDeleteAnomalyDetectorCommand, } from "../protocols/Aws_query";
var DeleteAnomalyDetectorCommand = (function (_super) {
    __extends(DeleteAnomalyDetectorCommand, _super);
    function DeleteAnomalyDetectorCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    DeleteAnomalyDetectorCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "CloudWatchClient";
        var commandName = "DeleteAnomalyDetectorCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: DeleteAnomalyDetectorInput.filterSensitiveLog,
            outputFilterSensitiveLog: DeleteAnomalyDetectorOutput.filterSensitiveLog,
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    DeleteAnomalyDetectorCommand.prototype.serialize = function (input, context) {
        return serializeAws_queryDeleteAnomalyDetectorCommand(input, context);
    };
    DeleteAnomalyDetectorCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_queryDeleteAnomalyDetectorCommand(output, context);
    };
    return DeleteAnomalyDetectorCommand;
}($Command));
export { DeleteAnomalyDetectorCommand };
