import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { DeleteDashboardsInput, DeleteDashboardsOutput } from "../models/models_0";
import { deserializeAws_queryDeleteDashboardsCommand, serializeAws_queryDeleteDashboardsCommand, } from "../protocols/Aws_query";
var DeleteDashboardsCommand = (function (_super) {
    __extends(DeleteDashboardsCommand, _super);
    function DeleteDashboardsCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    DeleteDashboardsCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "CloudWatchClient";
        var commandName = "DeleteDashboardsCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: DeleteDashboardsInput.filterSensitiveLog,
            outputFilterSensitiveLog: DeleteDashboardsOutput.filterSensitiveLog,
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    DeleteDashboardsCommand.prototype.serialize = function (input, context) {
        return serializeAws_queryDeleteDashboardsCommand(input, context);
    };
    DeleteDashboardsCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_queryDeleteDashboardsCommand(output, context);
    };
    return DeleteDashboardsCommand;
}($Command));
export { DeleteDashboardsCommand };
