import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { DescribeAlarmsInput, DescribeAlarmsOutput } from "../models/models_0";
import { deserializeAws_queryDescribeAlarmsCommand, serializeAws_queryDescribeAlarmsCommand, } from "../protocols/Aws_query";
var DescribeAlarmsCommand = (function (_super) {
    __extends(DescribeAlarmsCommand, _super);
    function DescribeAlarmsCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    DescribeAlarmsCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "CloudWatchClient";
        var commandName = "DescribeAlarmsCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: DescribeAlarmsInput.filterSensitiveLog,
            outputFilterSensitiveLog: DescribeAlarmsOutput.filterSensitiveLog,
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    DescribeAlarmsCommand.prototype.serialize = function (input, context) {
        return serializeAws_queryDescribeAlarmsCommand(input, context);
    };
    DescribeAlarmsCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_queryDescribeAlarmsCommand(output, context);
    };
    return DescribeAlarmsCommand;
}($Command));
export { DescribeAlarmsCommand };
