import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { DescribeAnomalyDetectorsInput, DescribeAnomalyDetectorsOutput } from "../models/models_0";
import { deserializeAws_queryDescribeAnomalyDetectorsCommand, serializeAws_queryDescribeAnomalyDetectorsCommand, } from "../protocols/Aws_query";
var DescribeAnomalyDetectorsCommand = (function (_super) {
    __extends(DescribeAnomalyDetectorsCommand, _super);
    function DescribeAnomalyDetectorsCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    DescribeAnomalyDetectorsCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "CloudWatchClient";
        var commandName = "DescribeAnomalyDetectorsCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: DescribeAnomalyDetectorsInput.filterSensitiveLog,
            outputFilterSensitiveLog: DescribeAnomalyDetectorsOutput.filterSensitiveLog,
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    DescribeAnomalyDetectorsCommand.prototype.serialize = function (input, context) {
        return serializeAws_queryDescribeAnomalyDetectorsCommand(input, context);
    };
    DescribeAnomalyDetectorsCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_queryDescribeAnomalyDetectorsCommand(output, context);
    };
    return DescribeAnomalyDetectorsCommand;
}($Command));
export { DescribeAnomalyDetectorsCommand };
