import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { DescribeInsightRulesInput, DescribeInsightRulesOutput } from "../models/models_0";
import { deserializeAws_queryDescribeInsightRulesCommand, serializeAws_queryDescribeInsightRulesCommand, } from "../protocols/Aws_query";
var DescribeInsightRulesCommand = (function (_super) {
    __extends(DescribeInsightRulesCommand, _super);
    function DescribeInsightRulesCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    DescribeInsightRulesCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "CloudWatchClient";
        var commandName = "DescribeInsightRulesCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: DescribeInsightRulesInput.filterSensitiveLog,
            outputFilterSensitiveLog: DescribeInsightRulesOutput.filterSensitiveLog,
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    DescribeInsightRulesCommand.prototype.serialize = function (input, context) {
        return serializeAws_queryDescribeInsightRulesCommand(input, context);
    };
    DescribeInsightRulesCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_queryDescribeInsightRulesCommand(output, context);
    };
    return DescribeInsightRulesCommand;
}($Command));
export { DescribeInsightRulesCommand };
