import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { PutAnomalyDetectorInput, PutAnomalyDetectorOutput } from "../models/models_0";
import { deserializeAws_queryPutAnomalyDetectorCommand, serializeAws_queryPutAnomalyDetectorCommand, } from "../protocols/Aws_query";
var PutAnomalyDetectorCommand = (function (_super) {
    __extends(PutAnomalyDetectorCommand, _super);
    function PutAnomalyDetectorCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    PutAnomalyDetectorCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "CloudWatchClient";
        var commandName = "PutAnomalyDetectorCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: PutAnomalyDetectorInput.filterSensitiveLog,
            outputFilterSensitiveLog: PutAnomalyDetectorOutput.filterSensitiveLog,
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    PutAnomalyDetectorCommand.prototype.serialize = function (input, context) {
        return serializeAws_queryPutAnomalyDetectorCommand(input, context);
    };
    PutAnomalyDetectorCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_queryPutAnomalyDetectorCommand(output, context);
    };
    return PutAnomalyDetectorCommand;
}($Command));
export { PutAnomalyDetectorCommand };
