import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { PutInsightRuleInput, PutInsightRuleOutput } from "../models/models_0";
import { deserializeAws_queryPutInsightRuleCommand, serializeAws_queryPutInsightRuleCommand, } from "../protocols/Aws_query";
var PutInsightRuleCommand = (function (_super) {
    __extends(PutInsightRuleCommand, _super);
    function PutInsightRuleCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    PutInsightRuleCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "CloudWatchClient";
        var commandName = "PutInsightRuleCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: PutInsightRuleInput.filterSensitiveLog,
            outputFilterSensitiveLog: PutInsightRuleOutput.filterSensitiveLog,
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    PutInsightRuleCommand.prototype.serialize = function (input, context) {
        return serializeAws_queryPutInsightRuleCommand(input, context);
    };
    PutInsightRuleCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_queryPutInsightRuleCommand(output, context);
    };
    return PutInsightRuleCommand;
}($Command));
export { PutInsightRuleCommand };
