import { Command as $Command } from "@aws-sdk/smithy-client";
import { Handler, HttpHandlerOptions as __HttpHandlerOptions, MetadataBearer as __MetadataBearer, MiddlewareStack } from "@aws-sdk/types";
import { CloudWatchClientResolvedConfig, ServiceInputTypes, ServiceOutputTypes } from "../CloudWatchClient";
import { GetMetricStreamInput, GetMetricStreamOutput } from "../models/models_0";
export interface GetMetricStreamCommandInput extends GetMetricStreamInput {
}
export interface GetMetricStreamCommandOutput extends GetMetricStreamOutput, __MetadataBearer {
}

export declare class GetMetricStreamCommand extends $Command<GetMetricStreamCommandInput, GetMetricStreamCommandOutput, CloudWatchClientResolvedConfig> {
    readonly input: GetMetricStreamCommandInput;
    constructor(input: GetMetricStreamCommandInput);
    
    resolveMiddleware(clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>, configuration: CloudWatchClientResolvedConfig, options?: __HttpHandlerOptions): Handler<GetMetricStreamCommandInput, GetMetricStreamCommandOutput>;
    private serialize;
    private deserialize;
}
