import { ProviderResourceTypes } from "../operationsInterfaces";
import { ResourceManagementClient } from "../resourceManagementClient";
import { ProviderResourceTypesListOptionalParams, ProviderResourceTypesListResponse } from "../models";
/** Class containing ProviderResourceTypes operations. */
export declare class ProviderResourceTypesImpl implements ProviderResourceTypes {
    private readonly client;
    /**
     * Initialize a new instance of the class ProviderResourceTypes class.
     * @param client Reference to the service client
     */
    constructor(client: ResourceManagementClient);
    /**
     * List the resource types for a specified resource provider.
     * @param resourceProviderNamespace The namespace of the resource provider.
     * @param options The options parameters.
     */
    list(resourceProviderNamespace: string, options?: ProviderResourceTypesListOptionalParams): Promise<ProviderResourceTypesListResponse>;
}
//# sourceMappingURL=providerResourceTypes.d.ts.map